#Compiler PBWin 10
#Compile Exe  "gbflyzapper.exe"
#Dim All
%Unicode = 1
#Include "Win32API.inc"

#Resource Icon fly, "images\fly.ico"
#Resource Icon zapper, "images\zapper.ico"
#Resource Icon deadfly, "images\deadfly.ico"

#Resource Icon SoundOff, "images\sound.ico"
#Resource Icon PathOn, "images\path.ico"
#Resource Icon PathPreview, "images\preview.ico"
#Resource Icon Slow, "images\slow.ico"
#Resource Icon Help, "images\help.ico"
#Resource Icon GameOn, "images\stop.ico"
#Resource Icon NewGame, "images\new.ico"

#Resource Wave buzz, "sounds\buzz.wav"
#Resource Wave zap, "sounds\zap.wav"

$Ver = "1.1"
Enum Equates Singular
   IDC_Graphic = 500
   IDC_Toolbar

   IDT_GameOn
   IDT_SoundOff
   IDT_Path
   IDT_Slow
   IDT_PathPreview
   IDT_NewGame
   IDT_Help

   ID_Timer
   ninc = 100
End Enum

Global hDlg,hFont As Dword, xlimit, ylimit, iPos As Long, ZapperName$
Global xbrown0, xbrown1, ybrown0, ybrown1, Slower, GameOn As Long
Global PathPreview, ShowPath, SoundOff, PixelsPerInterval As Long
Global xbrown(), ybrown(), xbrownsmooth(), ybrownsmooth() As Long
Global zapperR,flyR,zapperRS,flyRS As Rect, theta As Single
Global hDC, hBMPF, hDCF, hBMPFD, hDCFD, hBMPR, hDCR As Dword

Function PBMain() As Long
   Dialog New Pixels, 0, "gbFlyZapper  " + $Ver,300,300,300,300, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "fly"
   CreateToolbar
   Control Add Graphic, hDlg, %IDC_Graphic,"Push",0,55,400,400, %SS_Notify Or %WS_Border
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Get DC To hDC
   Graphic Color %rgb_DarkGray, %rgb_DarkGray
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         SetMenusAndToolbar
         Font New "Tahoma",10,0 To hFont
         Control Set Font hDlg, %IDC_Toolbar, hFont
         'save the fly to a bmp/dc
         Graphic Bitmap New 32, 32 To hBMPF
         Graphic Attach hBMPF, 0
         Graphic Render Icon "fly", (0,0)-(31,31)
         Graphic Get DC To hDCF
         'save the dead fly to a bmp/dc
         Graphic Bitmap New 32, 32 To hBMPFD
         Graphic Attach hBMPFD, 0
         Graphic Render Icon "deadfly", (0,0)-(31,31)
         Graphic Get DC To hDCFD
         'create 70x70 intermedicate bitmap to hold rotated bitmaps
         Graphic Bitmap New 50,50 To hBMPR
         Graphic Attach hBMPR,0
         Graphic Color %Black, %Black
         Graphic Get DC To hDCR
         'start the action
         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         ZapperName$ = "zapper"
         ReDim xbrown(%ninc*2), ybrown(%ninc*2), xbrownsmooth(%ninc), ybrownsmooth(%ninc)
         Randomize Timer
         SetTimer hDlg, %ID_Timer, IIf(Slower,250,25), 0
         If SoundOff=0 Then Play Wave "buzz", Loop

      Case %WM_Size
         Dialog Get Client hDlg To xlimit,ylimit : ylimit -= 55
         Control Set Client hDlg, %IDC_Graphic, xlimit,ylimit
         SetRect zapperR, xlimit-128, ylimit\2-64, xlimit,ylimit\2+64  'Zapper bounding rectangle
         SetRect zapperRS, xlimit-80, ylimit\2-14, xlimit-40,ylimit\2+44  'Zapper bounding rectangle
         Graphic Clear

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_GameOn
               GameOn Xor= 1
            Case %IDT_NewGame
               Reset xbrown0, xbrown1, xbrown(), xbrownsmooth(), iPos  'new fly
               Reset ybrown0, ybrown1, ybrown(), ybrownsmooth()
               Graphic Clear

            Case %IDT_SoundOff
               SoundOff Xor= 1
               If SoundOff Then Play Wave End Else Play Wave "buzz", Loop
            Case %IDT_PathPreview
               PathPreview Xor= 1
            Case %IDT_Path
               ShowPath Xor= 1
               If ShowPath Then Graphic Clear
            Case %IDT_Slow
               KillTimer hDlg, %ID_Timer
               Slower Xor= 1
               If Slower Then
                  PixelsPerInterval = 1
                  SetTimer hDlg, %ID_Timer, 50, 0
               Else
                  PixelsPerInterval = 10
                  SetTimer hDlg, %ID_Timer, 25, 0
               End If
            Case %IDT_Help
               temp$ = "The fly buzzes around until he gets zapped!"
               temp$ += $CrLf + $CrLf + "All settings are made via the toolbar"
               temp$ += $CrLf + $CrLf + "On: Start/Pause the app"
               temp$ += $CrLf + "Sound: Enbles the fly's buzzing noise"
               temp$ += $CrLf + "New: Starts a new path"
               temp$ += $CrLf + "Preview: Shows a partial path the fly will follow"
               temp$ += $CrLf + "Slow: Drops speed way down to enable inspection of the path"
               temp$ += $CrLf + "Path: Displays only the smooth fly path"
               temp$ += $CrLf + "Help: This popup dialog"

               MsgBox  temp$, %MB_TaskModal + %MB_IconInformation + %MB_Ok, "gbFlyZapper   v" + $Ver
         End Select

      Case %WM_Timer
         If GameOn Then DrawCanvas

      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         Settings_INI "save"
   End Select
End Function

Function GetFlyPath() As Long
  Local i, j As Long, a,b As Single
  xbrown1 = xbrown0 + Rnd(-100,100) : ybrown1 = ybrown0 + Rnd(-100,100)
  If (xbrown1>xlimit) Or (xbrown1<0) Then xbrown1 = xbrown0
  If (ybrown1>ylimit) Or (ybrown1<0) Then ybrown1 = xbrown0
  For j = 0 To %ninc - 1    'create points which form a straight line between the two points
     xbrown(%ninc + j) = xbrown0 + (xbrown1 - xbrown0) * j / %ninc
     ybrown(%ninc + j) = ybrown0 + (ybrown1 - ybrown0) * j / %ninc
  Next
  xbrown0 = xbrown1 : ybrown0 = ybrown1
  For i = 0 To %ninc   'smooth the points between the two lines
     a = 0 : b = 0
     For j = 0 To %ninc - 1
        a = a + xbrown(i + j) : b = b + ybrown(i + j)
     Next
     xbrownsmooth(i) = a / %ninc : ybrownsmooth(i) = b / %ninc
     If i <> %ninc Then xbrown(i) = xbrown(%ninc + i) : ybrown(i) = ybrown(%ninc + i)
  Next
End Function

Sub ShowRotatedFly(theta As Single, hDCTemp As Dword)
   Local x,y,XCenter, YCenter As Long
   Dim PlgPts(0 To 2) As PointAPI
   XCenter = 16 : YCenter = 16
   x = 0 : y = 0   'point in original bitmap
   PlgPts(0).X = XCenter + (x - XCenter) * Cos(theta) - (y - YCenter) * Sin(theta)  'upper-left in target
   PlgPts(0).Y = YCenter + (x - XCenter) * Sin(theta) + (y - YCenter) * Cos(theta)
   x = 32 : y = 0   'point in original bitmap
   PlgPts(1).X = XCenter + (x - XCenter) * Cos(theta) - (y - YCenter) * Sin(theta)  'upper-right in target
   PlgPts(1).Y = YCenter + (x - XCenter) * Sin(theta) + (y - YCenter) * Cos(theta)
   x = 0 : y = 32   'point in original bitmap
   PlgPts(2).X = XCenter + (x - XCenter) * Cos(theta) - (y - YCenter) * Sin(theta)  'lower left in target
   PlgPts(2).Y = YCenter + (x - XCenter) * Sin(theta) + (y - YCenter) * Cos(theta)
   Graphic Attach hBMPR, 0
   Graphic Clear
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   PlgBlt(hDCR, PlgPts(0), hDCTemp, 0, 0, 32,32, 0&, 0, 0)  ' Draw rotated image
   TransparentBlt hDC,flyR.nLeft,flyR.nTop,50,50,hDCR,0,0,50,50,%Black
End Sub

Sub CreateToolbar
    Local hImageList,hToolbar As Dword
    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "SoundOff" '1
    ImageList Add Icon hImageList, "PathOn"   '2
    ImageList Add Icon hImageList, "Help"     '3
    ImageList Add Icon hImageList, "Slow"     '4
    ImageList Add Icon hImageList, "GameOn"   '5
    ImageList Add Icon hImageList, "PathPreview" '6
    ImageList Add Icon hImageList, "NewGame" '7

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_GameOn, %BTNS_Check, "On"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_NewGame, %BTNS_Button, "New"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_SoundOff, %BTNS_Check, "Silent"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_PathPreview, %BTNS_Check, "Preview"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Slow, %BTNS_Check, "Slow"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Path, %BTNS_Check, "Path"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button, "Help"
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "350", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
'      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "PathPreview", "0", temp, %Max_Path, INIFileName:  PathPreview = Val(temp)
      Getprivateprofilestring "All", "ShowPath", "0", temp, %Max_Path, INIFileName:  ShowPath = Val(temp)
      Getprivateprofilestring "All", "SoundOff", "0", temp, %Max_Path, INIFileName:  SoundOff = Val(temp)
      Getprivateprofilestring "All", "Slower", "0", temp, %Max_Path, INIFileName:  Slower = Val(temp)
      Getprivateprofilestring "All", "GameOn", "1", temp, %Max_Path, INIFileName:  GameOn = Val(temp)
      Getprivateprofilestring "All", "PixelsPerInterval", "10", temp, %Max_Path, INIFileName:  PixelsPerInterval = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
'      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "PathPreview", Str$(PathPreview), INIFileName
      WritePrivateProfileString "All", "ShowPath", Str$(ShowPath), INIFileName
      WritePrivateProfileString "All", "SoundOff", Str$(SoundOff), INIFileName
      WritePrivateProfileString "All", "Slower", Str$(Slower), INIFileName
      WritePrivateProfileString "All", "GameOn", Str$(GameOn), INIFileName
      WritePrivateProfileString "All", "PixelsPerInterval", Str$(PixelsPerInterval), INIFileName
   End If
End Sub

Function ATN2 (ByVal Y As Ext,ByVal X As Ext) As Ext
  #Register None
  Dim Res As Ext

  !fld y##    ;Get y onto the FPU stack
  !fld x##    ;Get x onto the FPU stack
  !fpatan     ;Get the ATAN(y/x), Put result In ST(1) Then pop the stack
  !fstp res##   ;store the result In res## And pop the stack

  Function = Res
End Function

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_GameOn, IIf(GameOn,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Soundoff, IIf(SoundOff,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Path,  IIf(ShowPath,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_PathPreview,  IIf(PathPreview,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Slow,  IIf(Slower,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
'    Menu Set State hSettings, ByCmd %IDM_OnTop, OnTop * %MFS_Checked Or %MFS_Enabled
End Sub

Sub DrawCanvas
   Local i,j As Long, r As Rect
   For i = 1 To PixelsPerInterval
      If iPos = 0 Then GetFlyPath
      If ShowPath Then
         Graphic Set Pixel (xbrownsmooth(iPos),ybrownsmooth(iPos)), IIf(iPos,%Red,%Blue)
         Graphic ReDraw
         'next location
         Incr iPos : If iPos >= %ninc Then iPos = 0
      Else
         Graphic Clear
         Graphic Render Icon ZapperName$, (zapperR.nLeft,zapperR.nTop)-(zapperR.nRight,zapperR.nBottom) 'zapper icon
         SetRect flyR,xbrownsmooth(iPos)-16, ybrownsmooth(iPos)-16, xbrownsmooth(iPos)+16, ybrownsmooth(iPos)+16  'fly bounding rectangle
         SetRect flyRS,xbrownsmooth(iPos)-10, ybrownsmooth(iPos)-12, xbrownsmooth(iPos)+10, ybrownsmooth(iPos)+12  'fly bounding rectangle

         'aide to seeing angle of fly vs path
         If PathPreview Then
            For j = 0 To %ninc
               Graphic Set Pixel (xbrownsmooth(j),ybrownsmooth(j)), IIf(iPos,%Red,%Blue)
            Next j
         End If

         'calculate theta
         Local x,y As Ext
         y = ybrownsmooth(iPos+3)-ybrownsmooth(iPos-1) :  x = xbrownsmooth(iPos+3)-xbrownsmooth(iPos-1)
         theta = atn2(y,x) + 3.1416/2

         'rotate fly image/place on canvas
         ShowRotatedFly theta, hDCF
         Graphic ReDraw
         Incr iPos : If iPos >= %ninc Then iPos = 0  'if needed, get next path segment

         'check for collision between bug and zapper
         IntersectRect r, zapperRS, flyRS   'detect collision of bounding rectangles
         If IsRectEmpty(r) = 0 Then
            If SoundOff=0 Then Play Wave End : Play Wave "zap", NoStop
            Reset xbrown0, xbrown1, xbrown(), xbrownsmooth(), iPos  'new fly
            Reset ybrown0, ybrown1, ybrown(), ybrownsmooth()
            Graphic Clear
            Graphic Render Icon ZapperName$, (zapperR.nLeft,zapperR.nTop)-(zapperR.nRight,zapperR.nBottom) 'zapper icon
            ShowRotatedFly 0.7, hDCFD
            Graphic ReDraw
            Sleep 500
            If SoundOff=0 Then Play Wave "buzz", Loop
         End If
      End If
   Next i
End Sub
